"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPrettyMessage = exports.getPrettyMessageFromError = void 0;
var path = __importStar(require("path"));
var url_1 = __importDefault(require("url"));
var chalk_1 = __importDefault(require("chalk"));
var dedent_1 = __importDefault(require("dedent"));
var getPrettyMessageFromError = function (e, code, uri, cwd) {
    var info = e.info || e;
    return info.range ? (0, exports.getPrettyMessage)(info, code, uri, cwd) : null;
};
exports.getPrettyMessageFromError = getPrettyMessageFromError;
var getPrettyMessage = function (_a, code, uri, cwd) {
    var range = _a.range, message = _a.message;
    var lines = code.split("\n");
    var chunk = lines.slice(range.start.line - 1, range.end.line);
    var highlightedLines = chunk.reduce(function (highlight, line, index) {
        highlight.push(addLineNumber(line, range.start.line + index, lines.length));
        if (index === 0) {
            var underscoreLength = void 0;
            // same line
            if (range.end.line === range.start.line) {
                underscoreLength = range.end.column - (range.start.column - 1);
            }
            else {
                underscoreLength = line.length - range.start.column + 2;
            }
            highlight.push(addLineNumberPadding(" ".repeat(range.start.column - 1) + underline(underscoreLength), lines.length));
        }
        // make sure that end is on a new line
        if (range.start.line !== range.end.line && index !== 0) {
            // in-between lines
            if (range.start.line + index < range.end.line && line.trim()) {
                highlight.push(addLineNumberPadding(underline(line.length), lines.length));
                // end of line
            }
            else if (range.start.line + index === range.end.line) {
                highlight.push(addLineNumberPadding(underline(range.end.column - 1), lines.length));
            }
        }
        return highlight;
    }, []);
    var buffer = (0, dedent_1.default)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  \n\n  ", ":", " - ", ": ", "\n\n\n  "], ["\n  \\n\n  ", ":", " - ", ": ", "\\n\\n\n  "])), chalk_1.default.cyan(path.relative(cwd, url_1.default.fileURLToPath(uri))), chalk_1.default.yellow(range.start.line + ":" + range.start.column), chalk_1.default.red("error"), message) +
        highlightedLines.join("\n") +
        "\n";
    return buffer;
};
exports.getPrettyMessage = getPrettyMessage;
var underline = function (length) { return chalk_1.default.red("^".repeat(length)); };
var addLineNumber = function (line, number, high, colorize) {
    if (colorize === void 0) { colorize = true; }
    var prefix = "".concat(number) +
        " ".repeat(String(high).length + 2 - String(number).length) +
        "| ";
    return (colorize ? chalk_1.default.grey(prefix) : prefix) + line;
};
var addLineNumberPadding = function (line, high) {
    return " ".repeat(addLineNumber("", 0, high, false).length) + line;
};
var templateObject_1;
